% FILE NAME
%      SPSolve.m
% FUNCTION SIGNATURE
%      None
% INPUT PARAMETERS / ADDITIONAL PRE-CONDITIONS
%      Though this program has no proper input parameters, the following variables must
%      be initialized in the global data environment.
%      - parseflag = A boolean. This variable must be either zero or one. If it is zero, the program will
%                    not parse the model files into matlab. This saves run time if the model has already been parsed.
%      - dirnam    = A string. This is the path to the directory containing all of the model files. Must be formatted
%                    correctly for the operating system running the matlab session.
%      - modnam    = A string. The name of the model. This must also be the name of the file containing the model in 
%                    model-EZ syntax.
%      - parnam    = A string. The name of the parameter file, minus the file extension.
% OUTPUT PARAMETERS / ADDITIONAL POST-CONDITIONS
%      The program has no proper output parameters, but rather leaves all output
%      in the global data environment in Matlab.
% EXTERNAL DEPENDENCIES
%      The most recent version of the SPSolve program must exist in 
%      the directory pointed to by the eval function called in this 
%      code
% DESCRIPTION
%      This is a dummy program, which sets the proper paths to and 
%      then calls the most recent version of the matlab version of
%      SPSolve.
% VERSION HISTORY
%	Brian Ironside, 9/2002
%	      Original code written
%   adapted by Luca Guerrieri

%This code handles the execution of rest of the SPSolve program. Do not change.

%Paths for windows
	winSPActualPath = 'D:\matlab\aim\aimVer2.0\src\';
	winSPParserPath = 'D:\matlab\aim\aimVer2.0\parser\lib\';

addpath(winSPActualPath)
addpath(winSPParserPath)

%Once all this is set, we called the actual program
eval('SPSolveExe');