function [param_,np,modname,neq,nlag,nlead,eqname_,eqtype_,endog_,delay_,vtype_] = ...
     compute_aim_data()

% compute_aim_data()
%     This function will return various information about the AIM model,
%     but will not compute the G and H matrices.

  eqname = cell(26, 1);
  param = cell(35, 1);
  endog = cell(26, 1);
  delay = zeros(26, 1);
  vtype = zeros(26, 1);
  eqtype = zeros(26, 1);

  modname = 'PRICES';
  neq = 26;
  np = 35;
  nlag = 1;
  nlead = 1;

  eqname(1) = cellstr('ZETAFLEX');
  eqname(2) = cellstr('LFLEX');
  eqname(3) = cellstr('GDPFLEX');
  eqname(4) = cellstr('GDP');
  eqname(5) = cellstr('GDPGAP');
  eqname(6) = cellstr('LABOR');
  eqname(7) = cellstr('ZETAS');
  eqname(8) = cellstr('ZETAD');
  eqname(9) = cellstr('ZETA');
  eqname(10) = cellstr('PI');
  eqname(11) = cellstr('DW');
  eqname(12) = cellstr('REALBAL');
  eqname(13) = cellstr('MU');
  eqname(14) = cellstr('IRS');
  eqname(15) = cellstr('USHK');
  eqname(16) = cellstr('VSHK');
  eqname(17) = cellstr('XSHK');
  eqname(18) = cellstr('ZSHK');
  eqname(19) = cellstr('ONE');
  eqname(20) = cellstr('PRICE');
  eqname(21) = cellstr('WAGE');
  eqname(22) = cellstr('MONEY');
  eqname(23) = cellstr('EPSU');
  eqname(24) = cellstr('EPSV');
  eqname(25) = cellstr('EPSX');
  eqname(26) = cellstr('EPSZ');
  eqname_ = char(eqname);

  eqtype(1) = 1;     eqtype(2) = 1;     eqtype(3) = 1;   
  eqtype(4) = 1;     eqtype(5) = 1;     eqtype(6) = 1;   
  eqtype(7) = 1;     eqtype(8) = 1;     eqtype(9) = 1;   
  eqtype(10) = 1;     eqtype(11) = 1;     eqtype(12) = 1;   
  eqtype(13) = 1;     eqtype(14) = 1;     eqtype(15) = 1;   
  eqtype(16) = 1;     eqtype(17) = 1;     eqtype(18) = 1;   
  eqtype(19) = 1;     eqtype(20) = 1;     eqtype(21) = 1;   
  eqtype(22) = 1;     eqtype(23) = 0;     eqtype(24) = 0;   
  eqtype(25) = 0;     eqtype(26) = 0;   
  eqtype_ = eqtype;

  param(1) = cellstr('chi');
  param(2) = cellstr('ubar3');
  param(3) = cellstr('lscriptl');
  param(4) = cellstr('lscriptz');
  param(5) = cellstr('sigma');
  param(6) = cellstr('lscriptc');
  param(7) = cellstr('lscriptu');
  param(8) = cellstr('alpha');
  param(9) = cellstr('beta');
  param(10) = cellstr('kappap');
  param(11) = cellstr('kappa1');
  param(12) = cellstr('lscriptv');
  param(13) = cellstr('lambda');
  param(14) = cellstr('lscriptm');
  param(15) = cellstr('gampi');
  param(16) = cellstr('gamdw');
  param(17) = cellstr('gamg');
  param(18) = cellstr('gamy');
  param(19) = cellstr('gammu');
  param(20) = cellstr('gamp');
  param(21) = cellstr('gamw');
  param(22) = cellstr('gamm1');
  param(23) = cellstr('gamzeta1');
  param(24) = cellstr('gamu1');
  param(25) = cellstr('gamv1');
  param(26) = cellstr('gamx1');
  param(27) = cellstr('gamz1');
  param(28) = cellstr('gameu');
  param(29) = cellstr('gamev');
  param(30) = cellstr('gamex');
  param(31) = cellstr('gamez');
  param(32) = cellstr('rhou');
  param(33) = cellstr('rhov');
  param(34) = cellstr('rhox');
  param(35) = cellstr('rhoz');
  param_ = char(param);

  endog(1) = cellstr('zetaflex');
  endog(2) = cellstr('lflex');
  endog(3) = cellstr('gdpflex');
  endog(4) = cellstr('gdp');
  endog(5) = cellstr('gdpgap');
  endog(6) = cellstr('labor');
  endog(7) = cellstr('zetas');
  endog(8) = cellstr('zetad');
  endog(9) = cellstr('zeta');
  endog(10) = cellstr('pi');
  endog(11) = cellstr('dw');
  endog(12) = cellstr('realbal');
  endog(13) = cellstr('mu');
  endog(14) = cellstr('irs');
  endog(15) = cellstr('ushk');
  endog(16) = cellstr('vshk');
  endog(17) = cellstr('xshk');
  endog(18) = cellstr('zshk');
  endog(19) = cellstr('one');
  endog(20) = cellstr('price');
  endog(21) = cellstr('wage');
  endog(22) = cellstr('money');
  endog(23) = cellstr('epsu');
  endog(24) = cellstr('epsv');
  endog(25) = cellstr('epsx');
  endog(26) = cellstr('epsz');
  endog_ = char(endog);

  delay(1) = 0;     delay(2) = 0;     delay(3) = 0;   
  delay(4) = 0;     delay(5) = 0;     delay(6) = 0;   
  delay(7) = 0;     delay(8) = 0;     delay(9) = 0;   
  delay(10) = 0;     delay(11) = 0;     delay(12) = 0;   
  delay(13) = 0;     delay(14) = 0;     delay(15) = 0;   
  delay(16) = 0;     delay(17) = 0;     delay(18) = 0;   
  delay(19) = 0;     delay(20) = 0;     delay(21) = 0;   
  delay(22) = 0;     delay(23) = 0;     delay(24) = 0;   
  delay(25) = 0;     delay(26) = 0;   
  delay_ = delay;

  vtype(1) = 1;     vtype(2) = 1;     vtype(3) = 1;   
  vtype(4) = 0;     vtype(5) = 1;     vtype(6) = 1;   
  vtype(7) = 1;     vtype(8) = 1;     vtype(9) = 1;   
  vtype(10) = 0;     vtype(11) = 0;     vtype(12) = 1;   
  vtype(13) = 1;     vtype(14) = 0;     vtype(15) = 1;   
  vtype(16) = 1;     vtype(17) = 1;     vtype(18) = 1;   
  vtype(19) = 2;     vtype(20) = 1;     vtype(21) = 1;   
  vtype(22) = 1;     vtype(23) = 1;     vtype(24) = 1;   
  vtype(25) = 1;     vtype(26) = 1;   
  vtype_ = vtype;



