/*

  PARSE2.C	.MEX file to do second part of parsing; i.e.
		run routine that defines cofg and cofh given p.

  The calling syntax is:

                [cofg,cofh] = parse2(p,np,neq,nlag,nlead);

*/

#include <math.h>
#include "mex.h"
#include "matrix.h"

void mexFunction(nlhs,  plhs, nrhs, prhs)
int nlhs, nrhs;
mxArray *plhs[], *prhs[];
/* Matlab version update: Type of *plhs[] and *prhs[] was changed from Matrix to mxArray */
{
  int np,  neq,  nlag,  nlead, i;
  double *p,  *prnp, *cofg, *cofh, *prneq, *prnlag, *prnlead;  

	/* Check for proper number of arguments */

	if (nrhs != 5) {
		mexErrMsgTxt("PARSE2 requires five input arguments.");
	} else if (nlhs != 2) {
		mexErrMsgTxt("PARSE2 returns two output arguments.");
	}

        /* Dereference integer rhs variables */

	  prneq   = mxGetPr(prhs[2]);
	  prnlag  = mxGetPr(prhs[3]);
	  prnlead = mxGetPr(prhs[4]);

        /* Assign input arguments to local integers */

          neq   = (int)*(prneq);
          nlag  = (int)*(prnlag);
          nlead = (int)*(prnlead);


	/* Create matrices for the return arguments */
	/* Matlab version update: mxCreateFull was replaced by mxCreateDoubleMatrix
		and type for third argument changed from REAL to mxREAL */

	  plhs[0] = mxCreateDoubleMatrix(neq,neq*(nlag+1), mxREAL);
	  plhs[1] = mxCreateDoubleMatrix(neq,neq*(nlag+nlead+1), mxREAL);  

        /* Dereference the lhs and real rhs variables */

          p = mxGetPr(prhs[0]);

          cofg = mxGetPr(plhs[0]);
          cofh = mxGetPr(plhs[1]);

         /* Call the routine */

          compute_aim_matrices(p, &cofg, &cofh);

          mxSetPr(plhs[0],cofg);
          mxSetPr(plhs[1],cofh);

}

