#include <stdlib.h>

extern double pow();

void compute_aim_data(param, np, modname, neq, nlag, nlead,
                      eqname, eqtype, endog, delay, vtype)
     char ***param, **modname, ***eqname, ***endog;
     int *np, *neq, *nlag, *nlead, **eqtype, **delay, **vtype;
{
  *eqname = (char **) mxCalloc(11, sizeof(char*));
  *param = (char **) mxCalloc(7, sizeof(char*));
  *endog = (char **) mxCalloc(11, sizeof(char*));
  *delay = (int *) mxCalloc(11, sizeof(int));
  *vtype = (int *) mxCalloc(11, sizeof(int));
  *eqtype = (int *) mxCalloc(11, sizeof(int));

  *modname = "REALC2";
  *neq = 11;
  *np = 7;
  *nlag = 2;
  *nlead = 1;

  (*eqname)[0] = "PI";
  (*eqname)[1] = "F";
  (*eqname)[2] = "CONTR";
  (*eqname)[3] = "INDEX";
  (*eqname)[4] = "REALC";
  (*eqname)[5] = "CSHOCK";
  (*eqname)[6] = "FSHOCK";
  (*eqname)[7] = "PISTAR";
  (*eqname)[8] = "PISHOCK";
  (*eqname)[9] = "RHO";
  (*eqname)[10] = "ONE";

  (*eqtype)[0] = 1;     (*eqtype)[1] = 1;     (*eqtype)[2] = 1;   
  (*eqtype)[3] = 1;     (*eqtype)[4] = 1;     (*eqtype)[5] = 0;   
  (*eqtype)[6] = 0;     (*eqtype)[7] = 1;     (*eqtype)[8] = 1;   
  (*eqtype)[9] = 1;     (*eqtype)[10] = 1;   
  (*param)[0] = "DF1";
  (*param)[1] = "ALPHAP";
  (*param)[2] = "ALPHAPI";
  (*param)[3] = "ALPHADPI";
  (*param)[4] = "CRHO";
  (*param)[5] = "RHOBAR";
  (*param)[6] = "MU";

  (*endog)[0] = "PI";
  (*endog)[1] = "F";
  (*endog)[2] = "REALC";
  (*endog)[3] = "CONTR";
  (*endog)[4] = "CSHOCK";
  (*endog)[5] = "INDEX";
  (*endog)[6] = "FSHOCK";
  (*endog)[7] = "PISTAR";
  (*endog)[8] = "PISHOCK";
  (*endog)[9] = "RHO";
  (*endog)[10] = "ONE";

  (*delay)[0] = 0;     (*delay)[1] = 0;     (*delay)[2] = 0;   
  (*delay)[3] = 0;     (*delay)[4] = 0;     (*delay)[5] = 0;   
  (*delay)[6] = 0;     (*delay)[7] = 0;     (*delay)[8] = 0;   
  (*delay)[9] = 0;     (*delay)[10] = 0;   
  (*vtype)[0] = 0;     (*vtype)[1] = 0;     (*vtype)[2] = 1;   
  (*vtype)[3] = 1;     (*vtype)[4] = 1;     (*vtype)[5] = 1;   
  (*vtype)[6] = 1;     (*vtype)[7] = 1;     (*vtype)[8] = 1;   
  (*vtype)[9] = 1;     (*vtype)[10] = 2;   
}


void compute_aim_matrices(p, g, h)
     double *p, **g, **h;
{
  double DF1, ALPHAP, ALPHAPI,
         ALPHADPI, CRHO, RHOBAR,
         MU;
  int i;

  *g = (double *) mxCalloc(363, sizeof(double));
  *h = (double *) mxCalloc(484, sizeof(double));

  DF1 = p[0];
  ALPHAP = p[1];
  ALPHAPI = p[2];
  ALPHADPI = p[3];
  CRHO = p[4];
  RHOBAR = p[5];
  MU = p[6];

  for (i = 0; i < 363; i++)
    (*g)[i] = 0.0;

  for (i = 0; i < 484; i++)
    (*h)[i] = 0.0;

  (*g)[242] = (*g)[242] + 1;
  (*g)[297] = (*g)[297] - 1;
  (*g)[176] = (*g)[176] - (-1.00000000*1);
  (*g)[254] = (*g)[254] + 1;
  (*g)[133] = (*g)[133] + (-1.00000000*1);
  (*g)[133] = (*g)[133] - (DF1*1);
  (*g)[12] = (*g)[12] - (DF1*(-1.00000000*1));
  (*g)[298] = (*g)[298] - (ALPHAP*1);
  (*g)[243] = (*g)[243] - (ALPHAPI*1);
  (*g)[320] = (*g)[320] - (ALPHAPI*(-1.00000000*1));
  (*g)[243] = (*g)[243] - (ALPHADPI*1);
  (*g)[122] = (*g)[122] - (ALPHADPI*(-1.00000000*1));
  (*g)[309] = (*g)[309] - 1;
  (*g)[266] = (*g)[266] + 1;
  (*g)[277] = (*g)[277] - 1;
  (*g)[299] = (*g)[299] - (-1.00000000*1);
  (*g)[300] = (*g)[300] + 1;
  (*g)[278] = (*g)[278] - (0.50000000*1);
  (*g)[157] = (*g)[157] - (0.50000000*1);
  (*g)[279] = (*g)[279] + 1;
  (*g)[301] = (*g)[301] + (-1.00000000*1);
  (*g)[158] = (*g)[158] - (0.50000000*1);
  (*g)[180] = (*g)[180] - (0.50000000*(-1.00000000*1));
  (*g)[345] = (*g)[345] - (-1.00000000*(CRHO*1));
  (*g)[356] = (*g)[356] - (-1.00000000*(CRHO*(-1.00000000*(RHOBAR*1))));
  (*g)[290] = (*g)[290] - 1;
  (*h)[400] = (*h)[400] - (0.50000000*1);
  (*h)[422] = (*h)[422] - (0.50000000*(-1.00000000*1));
  (*g)[291] = (*g)[291] + 1;
  (*g)[357] = (*g)[357] - (0.00000000*1);
  (*g)[314] = (*g)[314] + 1;
  (*g)[358] = (*g)[358] - (0.00000000*1);
  (*g)[326] = (*g)[326] + 1;
  (*g)[205] = (*g)[205] - 1;
  (*g)[337] = (*g)[337] - 1;
  (*g)[338] = (*g)[338] + 1;
  (*g)[360] = (*g)[360] - (0.00000000*1);
  (*g)[350] = (*g)[350] + 1;
  (*g)[262] = (*g)[262] - (MU*1);
  (*h)[471] = (*h)[471] - (1.00000000*1);
  (*h)[471] = (*h)[471] - ((-1.00000000*MU)*1);
  (*h)[372] = (*h)[372] - (MU*(-1.00000000*1));
  (*g)[362] = (*g)[362] + 1;
  (*g)[241] = (*g)[241] - 1;
}
