
#include "header.h"

/*******************************************************************
  print_term() prints out the subtree rooted at the node pointed to 
  by its argument in a style suitable for updating the G and H
  matrices. Variables are printed out as 1's.
********************************************************************/

void print_term(n)
     struct node *n;
{
  switch (n->type) {
  case CONSTANT: 
    printf("%.8f", n->info.cons.value);
    break;
  case COEFFICIENT:
    printf("%s", n->info.coeff.name);
    break;
  case VARIABLE: 
    printf("1");
    break;
  case SUM:
    printf("(");
    print_term(n->info.sum.summand1);
    printf("+");
    print_term(n->info.sum.summand2);
    printf(")");
    break;
  case PRODUCT:
    printf("(");
    print_term(n->info.prod.multiplicand1);
    printf("*");
    print_term(n->info.prod.multiplicand2);
    printf(")");
    break;
  case POWER:
    printf("pow(");
    print_term(n->info.power.base);
    printf(",");
    print_term(n->info.power.exponent);
    printf(")");
    break;
  default:
    fprintf(stderr, "In print_term:");
    error(INVALID_NODE_TYPE);
  }
  return;
}

