% pcparsec - Parser setup for modelez syntax models
% For use with the C-mex parser

if(parseflag)

%  Clear old mex files if they exist:

   clear mex;

%  Parser output is a single file with two c functions:
%  compute_aim_data and compute_aim_matrices.

% UNIX specific stuff that is not needed - commented out 
%	[uaa,uver]=unix('/usr/bin/uname -r');
%   uver = str2num(uver(1));
%   if(uver==4)
%      % disp(['uver = ',num2str(uver)])
%      parsexpr = ...
%      ['! /mq/home/bin/mdlez-aim.sunos ',directory,modnam,' > ',...
%          directory,modnam,'.c'];
%   else 
%      parsexpr = ...
%      ['! /mq/home/bin/mdlez-aim.solaris ',directory,modnam,' > ',...
%          directory,modnam,'.c'];
%   end
%
%   parsexpr = ...
%   ['! /mq/home/unsp/aim/matlab/aim/mdlez-aim ',directory,modnam,' > ',...
%       directory,modnam,'.c'];

  if (printflag)
   parsexpr = ...
      ['! U:\tf\aim\parser\mdlez_aim ',directory,modnam,...
         ' > ',directory,modnam,'.c'];
  else 
   parsexpr = ...
      ['! U:\tf\aim\parser\mdlez_aim ',directory,modnam,...
         ' > ',directory,modnam,'.c 2> err.txt'];
  end
 
   if (printflag)
      space;
      disp('Parsing ...');
      space;
   end
   
eval(parsexpr);

%  Copy matlab gateway routines to model directory.  parse1.c is the 
%  gateway for compute_aim_data, and parse2.c is the gateway for 
%  compute_aim_matrices. cmex takes the name of its output from its
%  first argument, so we'll give the names we want to the gateway
%  routines and list them first on the cmex commands.

% UNIX
%    eval(['!cp /mq/home/aim/matlab/aim/parse1.c ',directory,modnam,'1.c'])
%    eval(['!cp /mq/home/aim/matlab/aim/parse2.c ',directory,modnam,'2.c'])
    
    eval(['!copy U:\tf\aim\parser\parse1.c ',directory,modnam,'1.c'])
    eval(['!copy U:\tf\aim\parser\parse2.c ',directory,modnam,'2.c'])

%  cmex commands to combine the gateway routines with the parser output.
%  object code for compute_aim_data     is in directory/modname,'1.dll'
%                  compute_aim_matrices is in directory/modname,'2.dll'
 
% UNIX
%	if(uver==4)
%     cmexexpr1 = ['! /opt/matlab/bin/cmex ',directory,modnam,'1.c ',directory,modnam,'.c '];
%     cmexexpr2 = ['! /opt/matlab/bin/cmex ',directory,modnam,'2.c ',directory,modnam,'.c '];
%   else
%      cmexexpr1 = ['! /opt/matlab/bin/cmex ',directory,modnam,'1.c ',directory,modnam,'.c '];
%      cmexexpr2 = ['! /opt/matlab/bin/cmex ',directory,modnam,'2.c ',directory,modnam,'.c '];
%   end         

	cmexexpr1 = ['mex ',directory,modnam,'1.c ',directory,modnam,'.c '];
   cmexexpr2 = ['mex ',directory,modnam,'2.c ',directory,modnam,'.c '];
      
   if (printflag)
      space;
      disp('Compiling compute_aim_data ...');
      eval(cmexexpr1);
      disp('Done.');
   end

end

% Run compute_aim_data:

[param_,np,modname,neq,nlag,nlead,eqname_,eqtype_,endog_,delay_,vtype_] = ...
             eval([modnam,'1']);
if(parseflag)
   
   seq  = find(eqtype_==0);
   dvar = find(vtype_==0);
   if(length(seq)~=length(dvar))
      error('Number of data variables not equal to number of stochastic equations.');
   end
end
   
   param_  = setstr(param_);
   endog_  = setstr(endog_);
   eqname_ = setstr(eqname_);
   modname = setstr(modname');

	param_  =  nmfix(param_);
  	endog_  =  nmfix(endog_);
  	eqname_ =  nmfix(eqname_);

% If parseflag=1, then display the output of compute_aim_data.

if(printflag & parseflag & length(param_) )
   space;
   disp('Parameter names');
   tabulator((1:np)',param_);
end

if(printflag & parseflag)
   space;
	disp(['Number of equations = ',num2str(neq)]);
	disp(['Number of lags      = ',num2str(nlag)]);
	disp(['Number of leads     = ',num2str(nlead)]);
	space;
	space;
	disp('endog_    delay_ vtype_ eqname_     eqtype_');
	tabulator(endog_,delay_,vtype_,eqname_,eqtype_);   space;
   disp('Compiling compute_aim_matrices ...');
   eval(cmexexpr2);
   disp('Done.');
end

