% pcparsem - Parser setup for modelez syntax models
% For use with the Matlab parser

if(parseflag)

	if (printflag)
        parsexpr = ...
            ['! d:\matlab\aim\parser\mdlez_aim_m ',directory,modnam];
    else
        parsexpr = ...
     		['! d:\matlab\aim\parser\mdlez_aim_m ',directory,modnam,...
      	' 2> err.txt'];
	end 

 	if (printflag)
    space;
    disp('Parsing ...');
    space;
    end 

 eval(parsexpr);
 parsexpr

end

% Run compute_aim_data:

[param_,np,modname,neq,nlag,nlead,eqname_,eqtype_,endog_,delay_,vtype_] = ...
	eval([modnam,'_aim_data']);

if(parseflag)
   
   seq  = find(eqtype_==0);
   dvar = find(vtype_==0);
   if(length(seq)~=length(dvar))
      error('Number of data variables not equal to number of stochastic equations.');
   end
end
   
   param_  = setstr(param_);
   endog_  = setstr(endog_);
   eqname_ = setstr(eqname_);
   modname = setstr(modname');

	param_  =  nmfix(param_);
  	endog_  =  nmfix(endog_);
  	eqname_ =  nmfix(eqname_);

% If parseflag=1, then display the output of compute_aim_data.

if(printflag & parseflag & length(param_) )
   space;
   disp('Parameter names');
   tabulator((1:np)',param_);
end

if(printflag & parseflag)
   space;
	disp(['Number of equations = ',num2str(neq)]);
	disp(['Number of lags      = ',num2str(nlag)]);
	disp(['Number of leads     = ',num2str(nlead)]);
	space;
	space;
	disp('endog_    delay_ vtype_ eqname_     eqtype_');
	tabulator(endog_,delay_,vtype_,eqname_,eqtype_);   space;
end

