clear
setpath

% modname below chooses model
% directory. But simple param choices are made from paramfile in current
% directory.
modnam = 'rbc';


TT = 120;            %length of IRFs

%model parameters
paramfilename1 = ['paramfile'];
paramfilename2 = ['defparamfile'];

% generate model IRFs

%% Pick innovation for IRFs

irfshock ='zverr';      % label for innovation for IRFs
scalefactormod = 1;        % scale factor for simulations
errlist = [];              % only needed for stochastic simulations

%% DO NOT EDIT THIS PART
eval(paramfilename1); eval(paramfilename2);

% solve model 
% eggmodfun calls matlab AIM routine.
% eggmofunsparse calls mex file with sparse AIM routine.
% eggmodfunsparse is only marginally faster for small models.
%[decrule,endog_]=eggmodfun(modname,paramfilename);
[decrule,endog_,scof]=eggmodfun(modnam,paramfilename1,paramfilename2);

wishlist = endog_
% generate IRFs for wishlist. IRFs are save in ZDATA
zdata = mkdata(TT,decrule,endog_,wishlist,errlist,irfshock,scalefactormod);

% unpack ZDATA
nwishes = size(wishlist,1);
for i=1:nwishes
    eval([wishlist(i,:),'=zdata(:,i);']);
end

%% EDIT SECTION BELOW TO VARY CHARTS PRODUCED
% make plot of IRFs
titlelist = char('Capital','Consumption','Investment','Technology');
figtitle = '';
legendlist = cellstr(char('simulation'));
makechart(titlelist,legendlist,figtitle,...
         [kv/kss,cv/css,iv/iss, zv]);
               