function addeq(equation,varname,vartype)

global  VARLIST TYPELIST EQLABEL EQTYPE EQUATIONLIST

% check if varname is already in header
if strmatch(varname,VARLIST,'exact')
    error(['the current model already contains an equation defining ',varname]);
end

% if not in header append varname to varlist
% add equation to equationlist
VARLIST = strvcat(VARLIST,lower(varname));
TYPELIST = strvcat(TYPELIST,vartype);

if (~isempty(strmatch(upper(vartype) ,'_NOTD','exact')))
    EQLABEL = strvcat(EQLABEL,['EQUATION > ',upper(varname)]);
    EQTYPE = strvcat(EQTYPE,'EQTYPE > IMPOSED');
    EQUATIONLIST = strvcat(EQUATIONLIST,['EQ > ',equation]);
elseif (~isempty(strmatch(upper(vartype) ,'_DATA','exact')))
    EQLABEL = strvcat(EQLABEL,['EQUATION > ',upper(varname)]);
    EQTYPE = strvcat(EQTYPE,'EQTYPE > STOCH');
    EQUATIONLIST = strvcat(EQUATIONLIST,['EQ > ',equation]);
elseif (~isempty(strmatch(upper(vartype) ,'_DTRM','exact')))
else
    error(['Unknown vartype for ',varname]);
end

    
    







