function filemod(filename,path)

% sets length after which equations are broken into multiple lines
stepsize = 75;

if nargin<2
    path = '.';
end

global  EQUATIONLIST VARLIST TYPELIST EQLABEL EQTYPE 
fid = fopen([path,'\',filename],'w');

fprintf(fid,['MODEL > ',filename,'\n']);

fprintf(fid,['ENDOG >','\n']);


%concatenate VARLIST and TYPELIST with dot separting them
templist = strcat(VARLIST,char(1),TYPELIST);
%remove dot and file
nvars = size(VARLIST,1);
for i = 1:nvars
   fprintf(fid,[strrep(templist(i,:),char(1),' '),'\n']);
end;

neqs = size(EQUATIONLIST,1);


for i = 1:neqs 
    fprintf(fid,[EQLABEL(i,:),'\n']);
    fprintf(fid,[EQTYPE(i,:),'\n']);
    if (length(deblank(EQUATIONLIST(i,:)))<75)    
        fprintf(fid,[deblank(EQUATIONLIST(i,:)),'\n']);  
    else
        % split equation into multiple lines
        plusindx = findstr(EQUATIONLIST(i,:),'+');
        minusindx = findstr(EQUATIONLIST(i,:),'-');
        allindex = [plusindx, minusindx];
        allindex = sort(allindex);
        
        issplit = 1;
        pos = stepsize;
        oldsplitpos  = 1;
        while (issplit)
            splitindex =find(allindex>pos);
            if isempty(splitindex)
                issplit = 0;
            else
                splitpos = allindex(min(splitindex));
                pos = splitpos+stepsize;
                fprintf(fid,[deblank(EQUATIONLIST(i,oldsplitpos:splitpos-1)),'\n']);
    
                oldsplitpos = splitpos;
            end
        end
        % glue back remainder of equation;
        fprintf(fid,[deblank(EQUATIONLIST(i,oldsplitpos:end)),'\n']);
    end
    fprintf(fid,'\n');
end



fprintf(fid,['END']);

fclose(fid);

clear global EQUATIONLIST VARLIST TYPELIST EQLABEL EQTYPE 