function [zdata]=mkdata_ab(amat,bmat,endog_,errlistfull,wishlist,errlist,errhistory,xiinit)
%amat,bmat,endogsmall,newerrlist,fitted_wish_list,newerrlist(i,:),errhistory(i,:),xiinit

%errlistfull is the list of all innovations
%errlist is the list of innovations to be turned on in generating data
%errhistory contains the values for the history of relevant innovations

%[nsim, ksim, ysim, isim, csim] = mkdata(nperiods,cofb,endog_)

nperiods = size(errhistory,2)+1;

% given decision rule 
neqs = size(endog_,1);

history = zeros(neqs,nperiods);

% find position of shocks in the vector of endogenous variables
nerrs = size(errlist,1);
errpos = zeros(size(errlist,1),1);

for errindx = 1:nerrs
    errpos(errindx) = strmatch(errlist(errindx,:),errlistfull,'exact');
end

history(:,1) = xiinit;

for i = 2:nperiods
    % update endogenous variables
    history(:,i) = amat* history(:,i-1) + bmat(:,errpos)*errhistory(:,i-1);
end

% list of variables we wish to extract from data matrix
%wishlist = char('eff','ukp','ugdp','uinv','ucc','kp');
nwish=size(wishlist,1);
wishpos = zeros(nwish,1);

history=history';
for i=1:nwish
    wishpos(i) = strmatch(wishlist(i,:),endog_,'exact');
end
zdata = history(1:end,wishpos);