function [zdata]=mkdata_decomp(nperiods,cofb,endog_,wishlist,errlist,errhistory)

%[nsim, ksim, ysim, isim, csim] = mkdata(nperiods,cofb,endog_)

% given decision rule 
neqs = size(endog_,1);

history = zeros(neqs,nperiods+1);

% find position of shocks in the vector of endogenous variables
nerrs = size(errlist,1);
errpos = zeros(size(errlist,1),1);
for errindx = 1:nerrs
    errpos(errindx) = strmatch(errlist(errindx,:),endog_,'exact');
end

% generate data
% history will contain data, the state vector at each period in time will
% be stored columnwise.
history = zeros(neqs,nperiods);

for i = 2:nperiods
    % set shocks 
    history(errpos,i-1) = errhistory(:,i);
    
    % update endogenous variables
    history(:,i) = cofb * history(:,i-1);
end

% list of variables we wish to extract from data matrix
%wishlist = char('eff','ukp','ugdp','uinv','ucc','kp');
nwish=size(wishlist,1);
wishpos = zeros(nwish,1);

history=history';
for i=1:nwish
    wishpos(i) = strmatch(wishlist(i,:),endog_,'exact');
end
zdata = history(2:end,wishpos);