function modedit(filename,arg)
global EQUATIONLIST HEADER VARLIST TYPELIST EQLABEL EQTYPE

if arg=='n'
    % arg = 'n' new model
    EQUATIONLIST = [];
    VARLIST = [];
    TYPELIST = [];
    EQLABEL = [];
    EQTYPE = [];
    
elseif arg=='o'
    % arg = 'o' existing model
    file = textread(filename,'%s','delimiter','\n');
    file = char(file);
    
    % get rid of blanks
    blankind = strmatch('',file,'exact');
    nfile = size(file,1);
    countblank = 1;
    countkeep = 1; 
    
    
    if ~isempty(blankind)
        %assumes last line is not blank
        nblanks = length(blankind);
        for i = 1:nfile-1
            if i ~= blankind(countblank)
                keepind(countkeep) = i;
                countkeep = countkeep+1;
            else
                if (countblank<nblanks)
                    countblank = countblank+1;
                end
            end
        end
        %deal with last line of the file
        if nfile ~= blankind(length(blankind))
            file = file([keepind nfile],:);
        else
            file = file(keepind,:);
        end;
    else
        countblank = 0;
        countkeep = nfile;
    end
    
    
    
    % look for beginning and end of header and equationlist portions
    startheader = strmatch('ENDOG >',file,'exact')+1;
    eqlabelind = strmatch('EQUATION >',file);
    endheader = eqlabelind(1)-1;
    endequationlist = strmatch('END',file,'exact')-1;
    
    HEADER = file(startheader:endheader,:);
    EQLABEL = file(eqlabelind,:);
    EQTYPE = file(eqlabelind+1,:);
    
    eqstart = eqlabelind+2;
    eqend = [eqlabelind(2:length(eqlabelind))-1; endequationlist];
    
    EQUATIONLIST = cellstr(num2str(zeros(size(eqend,1),1)));
    neqs = size(eqend,1);
    for i = 1:neqs
        equationstr = '';
        for jline = eqstart(i):eqend(i)
            equationstr = [equationstr,file(jline,:)];
        end
        EQUATIONLIST(i) = cellstr(equationstr);
    end
    
    EQUATIONLIST = char(EQUATIONLIST);
    
    
    % split header into varlist and typelist (varlist only contains
    % variable names).
    nheader = size(HEADER,1);
    VARLIST = cellstr(HEADER);
    TYPELIST = cellstr(HEADER);
    for i=1:nheader
        [var type] = strtok(HEADER(i,:));
        VARLIST(i) = cellstr(var);
        TYPELIST(i) = cellstr(type);
    end
    VARLIST = char(VARLIST);
    TYPELIST = char(TYPELIST);
    
else 
    error('argument not supported');
end