function p = normcdf(x,mu,sigma)

% x = normcdf(p,mu,sigma) returns the integral from minus infinity to x
% of the normal density function with mean mu 
% and standard deviation sigma 
%
% The function is a wrapper for cdfnor in the dcdflib library
% see http://people.sc.fsu.edu/~burkardt/f_src/dcdflib/dcdflib.html
% for additional documentation

if (min(size(x))>1)
    error('the first argument to betainv should be a vector or scalar only')
end
    
if (length(mu)>1 | length(sigma)>1)
    error('the second and third arguments to betainv can be a scalar only')
end

ncalls = length(x(:));

p = 0*x;

for i=1:ncalls
    p(i) = gateway_cdfnor(1,0.1,x(i),mu,sigma);
end