function x = norminv(p,mu,sigma)
% x = norminv(p,mu,sigma) returns the upper limit of integration
% of the normal density function with mean mu 
% and standard deviation sigma that yields p
%
% The function is a wrapper for cdfnor in the dcdflib library
% see http://people.sc.fsu.edu/~burkardt/f_src/dcdflib/dcdflib.html
% for additional documentation
    
if (length(mu)>1 | length(sigma)>1)
    error('the second and third arguments to betainv can be a scalar only')
end

ncalls = length(p(:));

x = 0*p;

for i=1:ncalls
    x(i) = gateway_cdfnor(2,p(i),x,mu,sigma);
end