function y = normpdf(x,mu,sigma)
% p = normpdf(x,mu,sigma) evaluates at x the
% normal density with mean mu and standard deviation sigma 
%
% see http://en.wikipedia.org/wiki/Normal_distribution
% for additional documentation

    
if (length(mu)>1 | length(sigma)>1)
    error('the second and third arguments to betainv can be a scalar only')
end

y = 1/(sigma*sqrt(2*pi))*exp(-(x-mu).^2/2/sigma^2);
