function endoglist = replicate_block(infilename,outfilename,prefixlist)


%% writing out
% rootoutputfilename='call_likel_dv_data.txt';
% fid = fopen(rootoutputfilename,'w+');
% fprintf( fid, 'neq = %d\n\n',neq );
% 
% psi4file = char(psi4file');
% rows = size(psi4file,1);

%infilename = 'eggtrade_notional.mod'
%outfilename = 'eggtrade_conversion.mod'

delimiters = char(',',';','(',')','+','-','^','*','/',' ','>','=');
numb3rs = char('1','2','3','4','5','6','7','8','9','0','.');
delimiters_cellstr = cellstr(strvcat(delimiters,'EQ','EQUATION','LEAD','LAG'));
%% read in file
% rawfile will be a cellstr array with 
rawfile = textread([infilename,'.txt'],'%s', ...
          'delimiter','\n','whitespace','','bufsize',40000);
      
nlines = size(rawfile,1);


fid = fopen([outfilename,'.txt'],'w+');

toggle = 0;
endoglist = '';

nprefixes = size(prefixlist,1);
for iprefix =1:nprefixes
    prefix = prefixlist(iprefix,:);
    for numline=1:nlines
        line = char(rawfile(numline));
        if ~isempty(line)
            tokens = tokenize(line,delimiters);
            ntokens = length(tokens);

            % go through tokens, if token is not a delimiter, append prefix.
            % loop is inefficiently written.
            % if strmatch below is satisfied, then the loop is done
            for itok = 1:ntokens

                if isempty(strmatch(tokens(itok),delimiters_cellstr,'exact'))
                    if strmatch(tokens(1),cellstr('EQUATION'),'exact')
                        tokens(5) = cellstr([upper(prefix),char(deblank(tokens(itok)))]);
                        endoglist = strvcat(endoglist,char(tokens(5)));
                        toggle = 1;
                    else
                        % check if first element is a number. If not,
                        % append prefix and overwrite token
                        tidbit = char(deblank(tokens(itok)));
                        if isempty(strmatch(tidbit(1),numb3rs))
                            tokens(itok) = cellstr([prefix,tidbit]);
                        end
                    end
                end
            end
            %overwrite line with the reassembled tokens  
            line = strmerge(tokens);

        end
        fprintf( fid, [line,'\n'] );
        if toggle
            fprintf( fid, 'EQTYPE > IMPOSED \n');
            toggle = 0;
        end

    end
end
fclose(fid);