function runsimfun(modnam,paramhistory,paramlabels,TT,paramfilename1,paramfilename2,irfshock,scalefactormod)

errlist = []; % only needed for stochastic simulations

%% DO NOT EDIT THIS PART
eval(paramfilename1);
eval(paramfilename2);

% solve model 
% eggmodfun calls matlab AIM routine.
% eggmofunsparse calls mex file with sparse AIM routine.
% eggmodfunsparse is only marginally faster for small models.
%[decrule,endog_]=eggmodfun(modname,paramfilename);
parseflag = 0;

[decrule,scof,endog_,xxxx,xxxxx,aimcode]= ...
    eggmodfunestim(modnam,paramfilename1,paramfilename2,parseflag,paramhistory,paramlabels);


wishlist = endog_
% generate IRFs for wishlist. IRFs are save in ZDATA
zdata = mkdata(TT,decrule,endog_,wishlist,errlist,irfshock,scalefactormod);

% unpack ZDATA
nwishes = size(wishlist,1);
for i=1:nwishes
    eval([wishlist(i,:),'=zdata(:,i);']);
end

%% EDIT SECTION BELOW TO VARY CHARTS PRODUCED
% make plot of IRFs
titlelist = char('GDP','Oil Production (Home GDP share)',...
                 'Consumption','Investment',...
                 'Oil Consumption (GDP share)','Real Oil Price',... 
                 'Real Exchange Rate','Trade Balance',...
                 'Imports (US GDP share)','Nonoil Balance (GDP share)');
figtitle = '';
legendlist = cellstr(char('Country 1','Country 2'));
figure1 = makechart(titlelist,legendlist,figtitle,...
         [c1gdp,c1oilprodshare,...
          c1c,c1i,...
          c1oilconshare, c1oilrelp,...
          c1rer,c1tbal,...
          c1impshare, c1sharexy*c1x - c1sharemy*c1m],...
         [c2gdp,c1oilprodsharefor,...
          c2c,c2i,...
          nan*c1oilconshare, nan*c1oilrelp,...
          nan*c1rer,c2tbal,...
          c1expshare, c2sharexy*c2x - c2sharemy*c2m]);

printpref

annotation(figure1,'textbox','String',{['Responses to ',irfshock]},...
    'FontWeight','bold',...
    'FontSize',12,...
    'FontName','Arial',...
    'FitHeightToText','off',...
    'LineStyle','none',...
    'Position',[0.4026 0.9713 0.2748 0.02144]);
     

     
     
                                                        